
var objCleanupCall = {
	// Prompt service and DOM Serializer. For debugging.
//	promptService: Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService),
	nsIDOMSerializer: Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].createInstance(Components.interfaces.nsIDOMSerializer),

	nsILocalFile: new Components.Constructor("@mozilla.org/file/local;1", "nsILocalFile"),
	preferences: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection."),
	prefPlatform: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection.platform."),

	nsISolRequest: Components.classes["@objection/solrequest;1"].createInstance(Components.interfaces.nsISolRequest),

	debugLevel: 10,

	observe: function(aSubject, aTopic, aData)
	{
		switch(aTopic)
		{
			case "profile-after-change":
				this.removeAutomatic('open');
				break;

			case "quit-application":
				this.removeAutomatic('close');
				break;

			default:
				throw Components.Exception("Unknown topic: " + aTopic);
		}
	},

	removeAutomatic: function(timeEvent)
	{
		// Get the debug level
		// Levels are: 1-All alerts, 5-Failure alerts, 10-No alerts
		this.debugLevel = 10;
		try {this.debugLevel = this.preferences.getIntPref("debugLevel");}catch (err) {}

		var automaticRemove = 'never';
		try
		{
			automaticRemove = this.preferences.getCharPref("automaticRemove");
		}
		catch (err)	{}
		if (timeEvent == automaticRemove)
		{
			// Init the File/Directory objects
			var flashAppDir = new this.nsILocalFile();
			var flashSettingDir = new this.nsILocalFile();
			var flashSettingFile = new this.nsILocalFile();
			var flashObjectDir = new this.nsILocalFile();

			// Test all the platforms to see which one this is
			var flashAppDirPref = this.testFlashDir();

			// If there is a valid path delete files
			if (flashAppDirPref !== null)
			{

				flashAppDir.initWithPath(flashAppDirPref);
				var flashObjectDirSet = false;
				flashObjectDir.initWithFile(flashAppDir);
				flashObjectDir.appendRelativePath('#SharedObjects');
				if (flashObjectDir.exists() && flashObjectDir.isDirectory())
				{
					try
					{
						var entries = flashObjectDir.directoryEntries;
						while(entries.hasMoreElements())
						{
							var entry = entries.getNext();
							entry.QueryInterface(Components.interfaces.nsIFile);
							if (entry.isDirectory())
							{
								flashObjectDir.initWithFile(entry);
								flashObjectDirSet = true;
								break;
							}
						}
					} catch(err) {}
					// Delete settings directories
					if (flashObjectDirSet)
					{
						try
						{
							var entries = flashObjectDir.directoryEntries;
							while(entries.hasMoreElements())
							{
								var entry = entries.getNext();
								entry.QueryInterface(Components.interfaces.nsIFile);
								if (entry.isDirectory())
								{
									try
									{
										entry.remove(true);
										this.jsdump('OBJECTION Remove lso:success:' + entry.path, 2);
									}
									catch (err)
									{
										this.jsdump('OBJECTION Remove lso:failed:' + entry.path + ' err:' + err, 5);
									}
								}
							}
						} catch(err)	{}
					}
					else
					{
						this.jsdump('OBJECTION Could not find:flashObjectDir:' + flashObjectDir.path, 3);
					}
				}
				automaticRemove = false;
				try
				{
					automaticRemoveSite = this.preferences.getBoolPref("automaticRemoveSite");
				}
				catch (err) {}
				// Remove the site settings as well, if requested
				if (automaticRemoveSite)
				{
					// Locate settings directories
					flashSettingDir.initWithFile(flashAppDir);
					flashSettingDir.appendRelativePath('macromedia.com');
					flashSettingDir.appendRelativePath('support');
					flashSettingDir.appendRelativePath('flashplayer');
					flashSettingDir.appendRelativePath('sys');
					if (flashSettingDir.exists() && flashSettingDir.isDirectory())
					{
						this.jsdump('OBJECTION flashSettingDir:' + flashSettingDir.path, 3);
						// Delete all lso directories (including the files)
						try
						{
							var entries = flashSettingDir.directoryEntries;
							while(entries.hasMoreElements())
							{
								var entry = entries.getNext();
								entry.QueryInterface(Components.interfaces.nsIFile);
								if (entry.isDirectory())
								{
									try
									{
										entry.remove(true);
										this.jsdump('OBJECTION Remove setting:success:' + entry.path, 2);
									}
									catch (err)
									{
										this.jsdump('OBJECTION Remove setting:failed:' + entry.path + ' err:' + err, 5);
									}
								}
							}
						} catch(err) {}
						// Remove domains from the settings file
						flashSettingFile.initWithFile(flashSettingDir);
						flashSettingFile.append('settings.sol');
						if (flashSettingFile.exists() && flashSettingFile.isFile())
						{
							var xmlSettingFile = this.nsISolRequest.solRead(flashSettingFile);
							if (xmlSettingFile !== null)
							{
								var xpe = Components.classes["@mozilla.org/dom/xpath-evaluator;1"].createInstance(Components.interfaces.nsIDOMXPathEvaluator);
								var nsResolver = xpe.createNSResolver(xmlSettingFile);
								var numDomains = xpe.evaluate("//data/element[@name='domains']/@number", xmlSettingFile, null, 2, null);
								if (numDomains !== null && numDomains.resultType == 2)
								{
									var resultsDomains = xpe.evaluate("//data/element[@parent='" + numDomains.stringValue + "']", xmlSettingFile, nsResolver, 4, null);
									resultsDomains.QueryInterface(Components.interfaces.nsIDOMXPathResult);  // not necessary in FF3, only 2.x and possibly earlier
									var res;
									var listDomains = [];
									while (res = resultsDomains.iterateNext())
									{
										listDomains.push(res);
									}
									if (listDomains.length > 0)
									{
										for (var i=0; i < listDomains.length; i++)
										{
											xmlSettingFile.firstChild.removeChild(listDomains[i]);
										}
										var writeSuccess = this.nsISolRequest.solWrite(xmlSettingFile, flashSettingFile);
										if (writeSuccess)
										{
											this.jsdump('OBJECTION Remove domains:success', 3);
										}
										else
										{
											this.jsdump('OBJECTION Remove domains:failed', 5);
										}
									}
								}
								else
								{
									this.jsdump('OBJECTION Remove domains:failed:(either no domains entry or known issue in Firefox 2.x)', 5);
								}
							}
						}
					}
				}
			}
		}
//					this.promptService.alert(null,'Objection','so far...');
	},

	testFlashDir: function()
	{
		var tempFlashDirPref = "";
		var tempFlashDir = new this.nsILocalFile();
		var allPlatform = this.prefPlatform.getChildList("", {});
		for (var i=0; i<allPlatform.length; i++)
		{
			if (this.prefPlatform.prefHasUserValue(allPlatform[i]) && typeof(this.prefPlatform.getCharPref(allPlatform[i])) != 'undefined')
			{
				tempFlashDirPref = this.prefPlatform.getCharPref(allPlatform[i]);
				if (tempFlashDirPref !== '')
				{
					try
					{
						tempFlashDir.initWithPath(tempFlashDirPref);
						if (tempFlashDir.exists() && tempFlashDir.isDirectory())
						{
							this.jsdump('OBJECTION Platform:' + allPlatform[i] + ':yes', 4);
							return tempFlashDirPref;
						}
					}
					catch(err)
					{
						this.jsdump('OBJECTION Platform:' + allPlatform[i] + ':no', 1);
					}
				}
			}
		}
		if (this.preferences.prefHasUserValue("flashAppDir") && typeof(this.preferences.getCharPref("flashAppDir")) != 'undefined')
		{
			try
			{
				tempFlashDirPref = this.preferences.getCharPref("flashAppDir");
				tempFlashDir.initWithPath(tempFlashDirPref);
				if (tempFlashDir.exists() && tempFlashDir.isDirectory())
				{
					this.jsdump('OBJECTION Platform:Old:yes', 4);
					return tempFlashDirPref;
				}
			}
			catch(err)
			{
				this.jsdump('OBJECTION Platform:Old:no', 1);
			}
		}
		return null;
	},

	jsdump: function(str, level)
	{
		if (level >= this.debugLevel)
		{
  			Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService).logStringMessage(str);
		}
	}
};


/***********************************************************
XPCOM
***********************************************************/

/***********************************************************
constants
***********************************************************/

// reference to the required base interface that all components must support
const nsISupports = Components.interfaces.nsISupports;

// UUID uniquely identifying our component
// You can get from: http://kruithof.xs4all.nl/uuid/uuidgen here
const CLASS_ID = Components.ID("{10060352-006A-11DD-84D9-524756D89593}");

// description
const CLASS_NAME = "Objection Cleanup Javascript XPCOM Component";

// textual unique identifier
const CONTRACT_ID = "@objection/cleanup;1";

// observer name
const MY_OBSERVER_NAME = "ObjectionCleanup";

/***********************************************************
class definition
***********************************************************/

//class constructor
function ObjectionCleanup() { };

// class definition
ObjectionCleanup.prototype = {

  // define the functions we want to expose in our interface
	observe: function(aSubject, aTopic, aData)
	{
		switch(aTopic)
		{
			case "xpcom-startup":
				// this is run very early, right after XPCOM is initialized, but before
				// user profile information is applied. Register ourselves as an observer
				// for 'profile-after-change' and 'quit-application'.
				var obsSvc = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
				obsSvc.addObserver(objCleanupCall, "profile-after-change", false);
				obsSvc.addObserver(objCleanupCall, "quit-application", false);
				break;

			default:
				throw Components.Exception("Unknown topic: " + aTopic);
		}
	},

  QueryInterface: function(aIID)
  {
	if (!aIID.equals(Components.interfaces.nsIObserver) &&
		!aIID.equals(nsISupports))
	  throw Components.results.NS_ERROR_NO_INTERFACE;
	return this;
  }
};

/***********************************************************
class factory
***********************************************************/
var ObjectionCleanupFactory = {
  createInstance: function (aOuter, aIID)
  {
	if (aOuter != null)
	  throw Components.results.NS_ERROR_NO_AGGREGATION;
	return (new ObjectionCleanup()).QueryInterface(aIID);
  }
};

/***********************************************************
module definition (xpcom registration)
***********************************************************/
var ObjectionCleanupModule = {
  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
  {
	aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
	aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);
	
	var catman = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
	catman.addCategoryEntry("xpcom-startup", MY_OBSERVER_NAME, CONTRACT_ID, true, true);
	catman.addCategoryEntry("xpcom-shutdown", MY_OBSERVER_NAME, CONTRACT_ID, true, true);
  },

  unregisterSelf: function(aCompMgr, aLocation, aType)
  {
	var catman = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
	catman.deleteCategoryEntry("xpcom-startup", MY_OBSERVER_NAME, true);
	aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
	aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);
  },

  getClassObject: function(aCompMgr, aCID, aIID)
  {
	if (!aIID.equals(Components.interfaces.nsIFactory))
	  throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

	if (aCID.equals(CLASS_ID))
	  return ObjectionCleanupFactory;

	throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aCompMgr) { return true; }
};

/***********************************************************
module initialization

When the application registers the component, this function
is called.
***********************************************************/
function NSGetModule(aCompMgr, aFileSpec) { return ObjectionCleanupModule; }